//+------------------------------------------------------------------+
//|Stochastic_Env.mq4.mq4
//| leonid553 & co) (  NoName)
//| 
//| http://www.tradersforum.net.ru/
//+------------------------------------------------------------------+
#property copyright "leonid553 & co"
#property link      "http://www.tradersforum.net.ru/"
//----------------------------------------------------

//---- input parameters---------
extern int     Stochastic_period=20;
extern int     Env_period=19;
extern int     Env_shift=1;
extern double  Env_deviation=20;
//------------------------------
extern int     TP_long=129;
extern int     SL_long=53;
extern int     TP_short=164;
extern int     SL_short=50;
extern double  Lot=0.1;
extern int     Slippage=3;
//-------------------
int   up_lim  =75;     // 
int   low_lim =25;     // 
//-------------------
int    ticket;
int    MAGIC;

color    clModifyBuy  = Green;
color    clModifySell = Blue;
//--   --
#include  <b-Lots.mqh> 
#include  <a-SimpleTrailing.mqh> 
//---------------------------

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if (Env_deviation==0) Env_deviation=0.1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//*********************************************************************

double Stochastic_array[49];
//------   Stochastic-----------------
int    i=0;
while (i<50)
 {
Stochastic_array[i]= iStochastic(NULL,0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, i);
i++;
 }
//------------------------------------------------------


ArraySetAsSeries(Stochastic_array,true);

double
En0_low=iEnvelopesOnArray(Stochastic_array,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,0);

double
En0_up=iEnvelopesOnArray(Stochastic_array,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,0);

double Stochastic_0=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, 0);
double Stochastic_1=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, 1);
Comment ("Stochastic_0 ", Stochastic_0, "\n",
         "En0_up       ", En0_up,       "\n",
          "En0_low     ", En0_low          );

 
//=====      =========================================================

int Orders=OrdersTotal ();     // -  
if (Orders==0)                 //   
  {  
//---------   ----------------------------
  if   (  /*(Stochastic_1<low_lim)  &&
          (Stochastic_0>low_lim)  &&*/
          (Stochastic_1<En0_low)  &&
          (Stochastic_0>En0_low)  )
   {
  Lots=GetSizeLot(); 
  ticket=OrderSend(Symbol(),0,Lots,Ask,Slippage,Bid-SL_long*Point,Ask+TP_long*Point,NULL,0,0,CLR_NONE);
  if    (ticket<0) { Print("   BUY #", GetLastError()); return (0); }  
  else
     {
     if (OrderSelect(ticket, SELECT_BY_TICKET) == true)
     
        { MAGIC=OrderMagicNumber(); }
         
     else  { Print("    BUY #", GetLastError() ); }
     }            
   }
//------------------------------------------------------------------

//--------   ------------------------------
  if  ( /*(Stochastic_1>up_lim)  &&
          (Stochastic_0<up_lim)  &&  */
          (Stochastic_1>En0_up)  &&
          (Stochastic_0<En0_up)) 
   { 
  Lots=GetSizeLot();      
  ticket=OrderSend(Symbol(),1,Lots,Bid,Slippage,Bid+SL_short*Point,Bid-TP_short*Point,NULL,0,0,CLR_NONE);
  if (ticket<0) { Print("   SELL #", GetLastError()); return (0); } 
  else
     {
     if (OrderSelect(ticket, SELECT_BY_TICKET) == true)
     
       { MAGIC=OrderMagicNumber(); }
       
     else  {Print("    SELL #", GetLastError() ); } 
     }                 
   }
  
//------------------------------------------------------------------
  }
//===============================================================================================
if (UseTrailing == true)  TrailingPositions(); 

//----
   return(0);
  }
//+------------------------------------------------------------------+


